<?php
/**
 * Clase Base DP para BaseArArqueoDetalleDepositoCobradorDP
 *
 * @package    
 * @subpackage BaseArArqueoDetalleDepositoCobradorDP
 * @author     Willy
 * @version    SVN:: BaseArArqueoDetalleDepositoCobradorDP.class.php,v 1.1 2021-08-30 23:16:16 william.taype Exp $
 */
abstract class BaseArArqueoDetalleDepositoCobradorDP extends ArArqueoDetalleDepositoCobradorBN
{
  /* N�mero de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof ArArqueoDetalleDepositoCobradorBN )
    {
      $o_ArArqueoDetalleDepositoCobradorBN = $bSetDefault;
      if($o_ArArqueoDetalleDepositoCobradorBN->getIdclase()) : $this->setIdclase($o_ArArqueoDetalleDepositoCobradorBN->getIdclase()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getIdsucursal()) : $this->setIdsucursal($o_ArArqueoDetalleDepositoCobradorBN->getIdsucursal()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getIdmercado()) : $this->setIdmercado($o_ArArqueoDetalleDepositoCobradorBN->getIdmercado()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getIdcolaborador()) : $this->setIdcolaborador($o_ArArqueoDetalleDepositoCobradorBN->getIdcolaborador()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getFecha()) : $this->setFecha($o_ArArqueoDetalleDepositoCobradorBN->getFecha()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getNumeroboucher()) : $this->setNumeroboucher($o_ArArqueoDetalleDepositoCobradorBN->getNumeroboucher()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getIdbanco()) : $this->setIdbanco($o_ArArqueoDetalleDepositoCobradorBN->getIdbanco()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getIdcuenta()) : $this->setIdcuenta($o_ArArqueoDetalleDepositoCobradorBN->getIdcuenta()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getBanco()) : $this->setBanco($o_ArArqueoDetalleDepositoCobradorBN->getBanco()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getNumerocuenta()) : $this->setNumerocuenta($o_ArArqueoDetalleDepositoCobradorBN->getNumerocuenta()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getFechadeposito()) : $this->setFechadeposito($o_ArArqueoDetalleDepositoCobradorBN->getFechadeposito()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getSubtotal()) : $this->setSubtotal($o_ArArqueoDetalleDepositoCobradorBN->getSubtotal()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getEstado()) : $this->setEstado($o_ArArqueoDetalleDepositoCobradorBN->getEstado()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getNombrearchivo()) : $this->setNombrearchivo($o_ArArqueoDetalleDepositoCobradorBN->getNombrearchivo()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getFecharegistro()) : $this->setFecharegistro($o_ArArqueoDetalleDepositoCobradorBN->getFecharegistro()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getUsuarioregistro()) : $this->setUsuarioregistro($o_ArArqueoDetalleDepositoCobradorBN->getUsuarioregistro()); endif;
      if($o_ArArqueoDetalleDepositoCobradorBN->getTipoarchivo()) : $this->setTipoarchivo($o_ArArqueoDetalleDepositoCobradorBN->getTipoarchivo()); endif;
    }
  }

  /* Obtiene el n�mero de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
    

      if($this->getIdclase() && $this->getIdsucursal() && $this->getIdmercado() && $this->getIdcolaborador() && $this->getFecha() && $this->getNumeroboucher()){
        $a_Fields = array();

        if($this->getIdclase()) : $a_Fields['idclase'] = ($this->getIdclase()); endif;
        if($this->getIdsucursal()) : $a_Fields['idsucursal'] = ($this->getIdsucursal()); endif;
        if($this->getIdmercado()) : $a_Fields['idmercado'] = ($this->getIdmercado()); endif;
        if($this->getIdcolaborador()) : $a_Fields['idcolaborador'] = ($this->getIdcolaborador()); endif;
        if($this->getFecha()) : $a_Fields['fecha'] = ($this->getFecha()); endif;
        if($this->getNumeroboucher()) : $a_Fields['numeroboucher'] = ($this->getNumeroboucher()); endif;
        if($this->getIdbanco()) : $a_Fields['idbanco'] = ($this->getIdbanco()); endif;
        if($this->getIdcuenta()) : $a_Fields['idcuenta'] = ($this->getIdcuenta()); endif;
        if($this->getBanco()) : $a_Fields['banco'] = ($this->getBanco()); endif;
        if($this->getNumerocuenta()) : $a_Fields['numerocuenta'] = ($this->getNumerocuenta()); endif;
        if($this->getFechadeposito()) : $a_Fields['fechadeposito'] = ($this->getFechadeposito()); endif;
        if($this->getSubtotal()) : $a_Fields['subtotal'] = ($this->getSubtotal()); endif;
        if($this->getEstado()) : $a_Fields['estado'] = ($this->getEstado()); endif;
        if($this->getNombrearchivo()) : $a_Fields['nombrearchivo'] = ($this->getNombrearchivo()); endif;
        if($this->getFecharegistro()) : $a_Fields['fecharegistro'] = ($this->getFecharegistro()); endif;
        if($this->getUsuarioregistro()) : $a_Fields['usuarioregistro'] = ($this->getUsuarioregistro()); endif;
        if($this->getTipoarchivo()) : $a_Fields['tipoarchivo'] = ($this->getTipoarchivo()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO ar_arqueo_detalle_deposito_cobrador (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }
  
   public function savelog()
  {
    try
    {
      $con = Conexion::getConexion();
     

      if($this->getIdclase() && $this->getIdsucursal() && $this->getIdmercado() && $this->getIdcolaborador() && $this->getFecha()  && $this->getNumeroboucher()){
        $a_Fields = array();

        if($this->getIdclase()) : $a_Fields['idclase'] = ($this->getIdclase()); endif;
        if($this->getIdsucursal()) : $a_Fields['idsucursal'] = ($this->getIdsucursal()); endif;
        if($this->getIdmercado()) : $a_Fields['idmercado'] = ($this->getIdmercado()); endif;
        if($this->getIdcolaborador()) : $a_Fields['idcolaborador'] = ($this->getIdcolaborador()); endif;
        if($this->getFecha()) : $a_Fields['fecha'] = ($this->getFecha()); endif;
        if($this->getIdbanco()) : $a_Fields['idbanco'] = ($this->getIdbanco()); endif;
        if($this->getIdcuenta()) : $a_Fields['idcuenta'] = ($this->getIdcuenta()); endif;
        if($this->getBanco()) : $a_Fields['banco'] = ($this->getBanco()); endif;
        if($this->getNumerocuenta()) : $a_Fields['numerocuenta'] = ($this->getNumerocuenta()); endif;
        if($this->getFechadeposito()) : $a_Fields['fechadeposito'] = ($this->getFechadeposito()); endif;
        if($this->getNumeroboucher()) : $a_Fields['numeroboucher'] = ($this->getNumeroboucher()); endif;
        if($this->getSubtotal()) : $a_Fields['subtotal'] = ($this->getSubtotal()); endif;
        if($this->getEstado()) : $a_Fields['estado'] = ($this->getEstado()); endif;
        if($this->getFecharegistro()) : $a_Fields['fecharegistro'] = ($this->getFecharegistro()); endif;
        if($this->getUsuarioregistro()) : $a_Fields['usuarioregistro'] = ($this->getUsuarioregistro()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO ar_arqueo_detalle_deposito_cobrador_log (idlogddc,".$sStringField.") VALUES (null,".$sStringValue.");";
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($con);
        }
        else
        {
          throw new Exception( mysql_error($con) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdclase() && $this->getIdsucursal() && $this->getIdmercado() && $this->getIdcolaborador() && $this->getFecha() && $this->getNumeroboucher())
      {
        $a_Fields = array();

        if($this->getIdclase()) : $a_Fields['idclase'] = ($this->getIdclase()); endif;
        if($this->getIdsucursal()) : $a_Fields['idsucursal'] = ($this->getIdsucursal()); endif;
        if($this->getIdmercado()) : $a_Fields['idmercado'] = ($this->getIdmercado()); endif;
        if($this->getIdcolaborador()) : $a_Fields['idcolaborador'] = ($this->getIdcolaborador()); endif;
        if($this->getFecha()) : $a_Fields['fecha'] = ($this->getFecha()); endif;
        if($this->getNumeroboucher()) : $a_Fields['numeroboucher'] = ($this->getNumeroboucher()); endif;
        if($this->getIdbanco()) : $a_Fields['idbanco'] = ($this->getIdbanco()); endif;
        if($this->getIdcuenta()) : $a_Fields['idcuenta'] = ($this->getIdcuenta()); endif;
        if($this->getBanco()) : $a_Fields['banco'] = ($this->getBanco()); endif;
        if($this->getNumerocuenta()) : $a_Fields['numerocuenta'] = ($this->getNumerocuenta()); endif;
        if($this->getFechadeposito()) : $a_Fields['fechadeposito'] = ($this->getFechadeposito()); endif;
        if($this->getSubtotal()) : $a_Fields['subtotal'] = ($this->getSubtotal()); endif;
        if($this->getEstado()) : $a_Fields['estado'] = ($this->getEstado()); endif;
        if($this->getNombrearchivo()) : $a_Fields['nombrearchivo'] = ($this->getNombrearchivo()); endif;
        if($this->getFecharegistro()) : $a_Fields['fecharegistro'] = ($this->getFecharegistro()); endif;
        if($this->getUsuarioregistro()) : $a_Fields['usuarioregistro'] = ($this->getUsuarioregistro()); endif;
        if($this->getTipoarchivo()) : $a_Fields['tipoarchivo'] = ($this->getTipoarchivo()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE ar_arqueo_detalle_deposito_cobrador SET ".$sStringField." WHERE 1 AND idclase='".$this->getIdclase()."' AND idsucursal='".$this->getIdsucursal()."' AND idmercado='".$this->getIdmercado()."' AND idcolaborador='".$this->getIdcolaborador()."' AND fecha='".$this->getFecha()."' AND numeroboucher='".$this->getNumeroboucher()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdclase() && $this->getIdsucursal() && $this->getIdmercado() && $this->getIdcolaborador() && $this->getFecha() && $this->getNumeroboucher())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM ar_arqueo_detalle_deposito_cobrador WHERE 1 AND idclase='".$this->getIdclase()."' AND idsucursal='".$this->getIdsucursal()."' AND idmercado='".$this->getIdmercado()."' AND idcolaborador='".$this->getIdcolaborador()."' AND fecha='".$this->getFecha()."' AND numeroboucher='".$this->getNumeroboucher()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* B�squeda del registro por la llave primaria */
  public static function selectByPK($vIdclase, $vIdsucursal, $vIdmercado, $vIdcolaborador, $vFecha, $vNumeroboucher)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, numeroboucher, idbanco, idcuenta, banco, numerocuenta, fechadeposito, subtotal, estado, nombrearchivo, fecharegistro, usuarioregistro, tipoarchivo FROM ar_arqueo_detalle_deposito_cobrador WHERE 1 AND idclase='".$vIdclase."' AND idsucursal='".$vIdsucursal."' AND idmercado='".$vIdmercado."' AND idcolaborador='".$vIdcolaborador."' AND fecha='".$vFecha."' AND numeroboucher='".$vNumeroboucher."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_ArArqueoDetalleDepositoCobradorDP = new ArArqueoDetalleDepositoCobradorDP();
    $o_ArArqueoDetalleDepositoCobradorDP->setIdclase($o_propel->idclase);
    $o_ArArqueoDetalleDepositoCobradorDP->setIdsucursal($o_propel->idsucursal);
    $o_ArArqueoDetalleDepositoCobradorDP->setIdmercado($o_propel->idmercado);
    $o_ArArqueoDetalleDepositoCobradorDP->setIdcolaborador($o_propel->idcolaborador);
    $o_ArArqueoDetalleDepositoCobradorDP->setFecha($o_propel->fecha);
    $o_ArArqueoDetalleDepositoCobradorDP->setNumeroboucher($o_propel->numeroboucher);
    $o_ArArqueoDetalleDepositoCobradorDP->setIdbanco($o_propel->idbanco);
    $o_ArArqueoDetalleDepositoCobradorDP->setIdcuenta($o_propel->idcuenta);
    $o_ArArqueoDetalleDepositoCobradorDP->setBanco($o_propel->banco);
    $o_ArArqueoDetalleDepositoCobradorDP->setNumerocuenta($o_propel->numerocuenta);
    $o_ArArqueoDetalleDepositoCobradorDP->setFechadeposito($o_propel->fechadeposito);
    $o_ArArqueoDetalleDepositoCobradorDP->setSubtotal($o_propel->subtotal);
    $o_ArArqueoDetalleDepositoCobradorDP->setEstado($o_propel->estado);
    $o_ArArqueoDetalleDepositoCobradorDP->setNombrearchivo($o_propel->nombrearchivo);
    $o_ArArqueoDetalleDepositoCobradorDP->setFecharegistro($o_propel->fecharegistro);
    $o_ArArqueoDetalleDepositoCobradorDP->setUsuarioregistro($o_propel->usuarioregistro);
    $o_ArArqueoDetalleDepositoCobradorDP->setTipoarchivo($o_propel->tipoarchivo);
    return $o_ArArqueoDetalleDepositoCobradorDP;
  }
}